<template>
  <BasicDrawer
    v-bind="$attrs"
    destroyOnClose
    @register="registerDrawer"
    :title="getTitle"
    :width="width"
    @ok="handleSubmit"
    :showFooter="true"
  >
    <BasicForm @register="registerForm" layout="vertical" class="!px-6 !pt-4" />
  </BasicDrawer>
</template>
<script lang="ts" setup>
  import { ref, reactive, unref } from 'vue';
  import { BasicDrawer, useDrawerInner } from '/@/components/Drawer';
  import { BasicForm, useForm } from '/@/components/Form';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { dataFormSchemaVascularAccess } from './data';
  import {
    archivesVascularAccessDetail,
    archivesVascularAccessEdit,
    archivesVascularAccessAdd,
  } from '/@/api/biz/archives/vascularAccessApi';
  import { listDictModel } from '/@/api/common';
  import { formatDictValue } from '/@/utils';

  const emit = defineEmits(['success', 'register']);

  const getTitle = ref(`血管通路`);
  const width = '35%';
  const isUpdate = ref(false);
  const rowId = ref();
  const patientBasicId = ref();
  const bizDictOptions = reactive({
    accessType: [],
  });
  const accessType = ref();

  const { createMessage } = useMessage();
  const [registerForm, { setFieldsValue, resetFields, validate }] = useForm({
    schemas: dataFormSchemaVascularAccess,
    showActionButtonGroup: false,
    baseColProps: {
      span: 24,
    },
  });
  const [registerDrawer, { setDrawerProps, closeDrawer }] = useDrawerInner(async data => {
    console.log('🚀 ~ file: FormDrawer.vue:49 ~ data:', data);
    await resetFields();
    setDrawerProps({ confirmLoading: false });
    bizDictOptions.accessType = await listDictModel({ dictCode: 'va_type' });
    isUpdate.value = !!data?.isUpdate;
    patientBasicId.value = data.record.id;
    if (unref(isUpdate)) {
      const resData = await archivesVascularAccessDetail(patientBasicId.value);
      rowId.value = resData.id;
      resData.accessType = resData.type;
      accessType.value = formatDictValue(bizDictOptions.accessType, resData.type);
      await setFieldsValue({
        ...resData,
      });
    } else {
      accessType.value = formatDictValue(bizDictOptions.accessType, data.record.accessType);
      await setFieldsValue({
        accessType: data.record.accessType,
      });
    }
    getTitle.value = `${isUpdate.value ? '编辑' : '新建'}${accessType.value}   ( ${
      data.record.name
    } | ${data.record.gender} | ${data.record.age} )`;
  });

  // 提交按钮事件
  async function handleSubmit() {
    try {
      const values = await validate();
      setDrawerProps({ confirmLoading: true });
      values.patientBasicId = patientBasicId.value;
      !unref(isUpdate)
        ? await archivesVascularAccessAdd({ ...values })
        : await archivesVascularAccessEdit({ ...values, id: rowId.value });
      !unref(isUpdate) ? createMessage.success('新增成功！') : createMessage.success('编辑成功！');
      closeDrawer();
      emit('success', {
        isUpdate: unref(isUpdate),
        values: { ...values, id: rowId.value },
      });
    } finally {
      setDrawerProps({ confirmLoading: false });
    }
  }
</script>
